

<!DOCTYPE html>
<!--[if IE 8]><html class="no-js lt-ie9" lang="en" > <![endif]-->
<!--[if gt IE 8]><!--> <html class="no-js" lang="en" > <!--<![endif]-->
<head>
  <meta charset="utf-8">
  
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  
  <title>Running a calibration with SHyFT &mdash; Documentation</title>
  

  
  
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
  
  
  

  
  <script type="text/javascript" src="../../_static/js/modernizr.min.js"></script>
  
    
      <script type="text/javascript" id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
        <script src="../../_static/jquery.js"></script>
        <script src="../../_static/underscore.js"></script>
        <script src="../../_static/doctools.js"></script>
        <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
        <script async="async" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.7/latest.js?config=TeX-AMS-MML_HTMLorMML"></script>
        <script type="text/x-mathjax-config">MathJax.Hub.Config({"tex2jax": {"inlineMath": [["$", "$"], ["\\(", "\\)"]], "processEscapes": true, "ignoreClass": "document", "processClass": "math|output_area"}})</script>
        <script src="../../_static/js/bootstrap.min.js"></script>
        <script src="../../_static/js/bootstrap.bundle.min.js"></script>
        <script src="../../_static/js/custom.js"></script>
    
    <script type="text/javascript" src="../../_static/js/theme.js"></script>

    

  
  <link rel="stylesheet" href="../../_static/css/theme.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/bootstrap.min.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/bootstrap-grid.min.css" type="text/css" />
  <link rel="stylesheet" href="../../_static/css/custom.css" type="text/css" />
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
    <link rel="next" title="Configured Shyft simulations" href="simulation-configured.html" />
    <link rel="prev" title="Constructing a model using the Shyft API" href="../shyft-intro-course-master/run_api_model.html" /> 
</head>

<body class="wy-body-for-nav">

   
  <div class="wy-grid-for-nav">
    
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
          

          
            <a href="../../index.html" class="icon icon-home"> Shyft
          

          
          </a>

          
            
            
              <div class="version">
                4.12
              </div>
            
          

          
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>

          
        </div>

        <div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="main navigation">
          
            
            
              
            
            
              <p class="caption"><span class="caption-text">Project</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/project/what_is_shyft.html">What is Shyft?</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/project/get_involved.html">Get involved</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/project/contact.html">Contact</a></li>
</ul>
<p class="caption"><span class="caption-text">Time Series</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/time_series/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Hydrology</span></p>
<ul class="current">
<li class="toctree-l1"><a class="reference internal" href="../../content/hydrology/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/hydrology/concepts.html">Concepts</a></li>
<li class="toctree-l1 current"><a class="reference internal" href="../../content/hydrology/getting_started.html">Getting started</a><ul class="current">
<li class="toctree-l2"><a class="reference internal" href="../../content/hydrology/getting_started.html#general-examples">General examples</a></li>
<li class="toctree-l2 current"><a class="reference internal" href="../../content/hydrology/getting_started.html#configured-simulation">Configured simulation</a><ul class="current">
<li class="toctree-l3 current"><a class="current reference internal" href="#">Running a calibration with SHyFT</a><ul>
<li class="toctree-l4"><a class="reference internal" href="#This-notebook-is-guiding-through-the-simulation-process-of-a-catchment.-The-following-steps-are-described:">This notebook is guiding through the simulation process of a catchment. The following steps are described:</a></li>
<li class="toctree-l4"><a class="reference internal" href="#1.-Loading-required-python-modules-and-setting-path-to-SHyFT-installation">1. Loading required python modules and setting path to SHyFT installation</a><ul>
<li class="toctree-l5"><a class="reference internal" href="#The-Shyft-Environment">The Shyft Environment</a></li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="#2.-Configuration-of-a-SHyFT-calibration">2. Configuration of a SHyFT calibration</a></li>
<li class="toctree-l4"><a class="reference internal" href="#3.-Running-a-SHyFT-calibration">3. Running a SHyFT calibration</a></li>
<li class="toctree-l4"><a class="reference internal" href="#4.-Inspecting-the-calibration-results">4. Inspecting the calibration results</a><ul>
<li class="toctree-l5"><a class="reference internal" href="#Plotting-simulated-and-observed-discharge">Plotting simulated and observed discharge</a></li>
</ul>
</li>
<li class="toctree-l4"><a class="reference internal" href="#5.-Changing-parameters-on-the-fly">5. Changing parameters on-the-fly</a><ul>
<li class="toctree-l5"><a class="reference internal" href="#5a.-Snow-or-rain?-The-parameter-gs.tx-sets-the-threshold-temperature-at-which-precipitation-is-treated-as-snow-fall.">5a. Snow or rain? The parameter gs.tx sets the threshold temperature at which precipitation is treated as snow fall.</a></li>
</ul>
</li>
</ul>
</li>
<li class="toctree-l3"><a class="reference internal" href="simulation-configured.html">Configured Shyft simulations</a></li>
<li class="toctree-l3"><a class="reference internal" href="run_nea_nidelva.html">A first simulation with Shyft</a></li>
<li class="toctree-l3"><a class="reference internal" href="advanced_simulation.html">Simulation with the Shyft API</a></li>
</ul>
</li>
<li class="toctree-l2"><a class="reference internal" href="../../content/hydrology/getting_started.html#advanced-tools">Advanced tools</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="../../content/hydrology/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Energy Market</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/energy_market/api.html">API Documentation</a></li>
</ul>
<p class="caption"><span class="caption-text">Dashboard</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/installation.html">Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/concepts.html">Concepts</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/getting_started.html">Getting started</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../content/dashboard/api.html">API Documentation</a></li>
</ul>

            
          
        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap">

      
      <nav class="wy-nav-top" aria-label="top navigation">
        
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../index.html">Shyft</a>
        
      </nav>


      <div class="wy-nav-content">
        
        <div class="rst-content">
        
          















<div role="navigation" aria-label="breadcrumbs navigation">

  <ul class="wy-breadcrumbs">
    
      <li><a href="../../index.html">Docs</a> &raquo;</li>
        
          <li><a href="../../content/hydrology/getting_started.html">Getting started</a> &raquo;</li>
        
      <li>Running a calibration with SHyFT</li>
    
    
      <li class="wy-breadcrumbs-aside">
        
            
            <a href="../../_sources/notebooks/nea-example/calibration-configured.ipynb.txt" rel="nofollow"> View page source</a>
          
        
      </li>
    
  </ul>

  
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
            
  
<style>
/* CSS for nbsphinx extension */

/* remove conflicting styling from Sphinx themes */
div.nbinput.container div.prompt *,
div.nboutput.container div.prompt *,
div.nbinput.container div.input_area pre,
div.nboutput.container div.output_area pre,
div.nbinput.container div.input_area .highlight,
div.nboutput.container div.output_area .highlight {
    border: none;
    padding: 0;
    margin: 0;
    box-shadow: none;
}

div.nbinput.container > div[class*=highlight],
div.nboutput.container > div[class*=highlight] {
    margin: 0;
}

div.nbinput.container div.prompt *,
div.nboutput.container div.prompt * {
    background: none;
}

div.nboutput.container div.output_area .highlight,
div.nboutput.container div.output_area pre {
    background: unset;
}

div.nboutput.container div.output_area div.highlight {
    color: unset;  /* override Pygments text color */
}

/* avoid gaps between output lines */
div.nboutput.container div[class*=highlight] pre {
    line-height: normal;
}

/* input/output containers */
div.nbinput.container,
div.nboutput.container {
    display: -webkit-flex;
    display: flex;
    align-items: flex-start;
    margin: 0;
    width: 100%;
}
@media (max-width: 540px) {
    div.nbinput.container,
    div.nboutput.container {
        flex-direction: column;
    }
}

/* input container */
div.nbinput.container {
    padding-top: 5px;
}

/* last container */
div.nblast.container {
    padding-bottom: 5px;
}

/* input prompt */
div.nbinput.container div.prompt pre {
    color: #307FC1;
}

/* output prompt */
div.nboutput.container div.prompt pre {
    color: #BF5B3D;
}

/* all prompts */
div.nbinput.container div.prompt,
div.nboutput.container div.prompt {
    width: 4.5ex;
    padding-top: 5px;
    position: relative;
    user-select: none;
}

div.nbinput.container div.prompt > div,
div.nboutput.container div.prompt > div {
    position: absolute;
    right: 0;
    margin-right: 0.3ex;
}

@media (max-width: 540px) {
    div.nbinput.container div.prompt,
    div.nboutput.container div.prompt {
        width: unset;
        text-align: left;
        padding: 0.4em;
    }
    div.nboutput.container div.prompt.empty {
        padding: 0;
    }

    div.nbinput.container div.prompt > div,
    div.nboutput.container div.prompt > div {
        position: unset;
    }
}

/* disable scrollbars on prompts */
div.nbinput.container div.prompt pre,
div.nboutput.container div.prompt pre {
    overflow: hidden;
}

/* input/output area */
div.nbinput.container div.input_area,
div.nboutput.container div.output_area {
    -webkit-flex: 1;
    flex: 1;
    overflow: auto;
}
@media (max-width: 540px) {
    div.nbinput.container div.input_area,
    div.nboutput.container div.output_area {
        width: 100%;
    }
}

/* input area */
div.nbinput.container div.input_area {
    border: 1px solid #e0e0e0;
    border-radius: 2px;
    /*background: #f5f5f5;*/
}

/* override MathJax center alignment in output cells */
div.nboutput.container div[class*=MathJax] {
    text-align: left !important;
}

/* override sphinx.ext.imgmath center alignment in output cells */
div.nboutput.container div.math p {
    text-align: left;
}

/* standard error */
div.nboutput.container div.output_area.stderr {
    background: #fdd;
}

/* ANSI colors */
.ansi-black-fg { color: #3E424D; }
.ansi-black-bg { background-color: #3E424D; }
.ansi-black-intense-fg { color: #282C36; }
.ansi-black-intense-bg { background-color: #282C36; }
.ansi-red-fg { color: #E75C58; }
.ansi-red-bg { background-color: #E75C58; }
.ansi-red-intense-fg { color: #B22B31; }
.ansi-red-intense-bg { background-color: #B22B31; }
.ansi-green-fg { color: #00A250; }
.ansi-green-bg { background-color: #00A250; }
.ansi-green-intense-fg { color: #007427; }
.ansi-green-intense-bg { background-color: #007427; }
.ansi-yellow-fg { color: #DDB62B; }
.ansi-yellow-bg { background-color: #DDB62B; }
.ansi-yellow-intense-fg { color: #B27D12; }
.ansi-yellow-intense-bg { background-color: #B27D12; }
.ansi-blue-fg { color: #208FFB; }
.ansi-blue-bg { background-color: #208FFB; }
.ansi-blue-intense-fg { color: #0065CA; }
.ansi-blue-intense-bg { background-color: #0065CA; }
.ansi-magenta-fg { color: #D160C4; }
.ansi-magenta-bg { background-color: #D160C4; }
.ansi-magenta-intense-fg { color: #A03196; }
.ansi-magenta-intense-bg { background-color: #A03196; }
.ansi-cyan-fg { color: #60C6C8; }
.ansi-cyan-bg { background-color: #60C6C8; }
.ansi-cyan-intense-fg { color: #258F8F; }
.ansi-cyan-intense-bg { background-color: #258F8F; }
.ansi-white-fg { color: #C5C1B4; }
.ansi-white-bg { background-color: #C5C1B4; }
.ansi-white-intense-fg { color: #A1A6B2; }
.ansi-white-intense-bg { background-color: #A1A6B2; }

.ansi-default-inverse-fg { color: #FFFFFF; }
.ansi-default-inverse-bg { background-color: #000000; }

.ansi-bold { font-weight: bold; }
.ansi-underline { text-decoration: underline; }


div.nbinput.container div.input_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight] > pre,
div.nboutput.container div.output_area div[class*=highlight].math,
div.nboutput.container div.output_area.rendered_html,
div.nboutput.container div.output_area > div.output_javascript,
div.nboutput.container div.output_area:not(.rendered_html) > img{
    padding: 5px;
    margin: 0;
}

/* fix copybtn overflow problem in chromium (needed for 'sphinx_copybutton') */
div.nbinput.container div.input_area > div[class^='highlight'],
div.nboutput.container div.output_area > div[class^='highlight']{
    overflow-y: hidden;
}

/* hide copybtn icon on prompts (needed for 'sphinx_copybutton') */
.prompt a.copybtn {
    display: none;
}

/* Some additional styling taken form the Jupyter notebook CSS */
div.rendered_html table {
  border: none;
  border-collapse: collapse;
  border-spacing: 0;
  color: black;
  font-size: 12px;
  table-layout: fixed;
}
div.rendered_html thead {
  border-bottom: 1px solid black;
  vertical-align: bottom;
}
div.rendered_html tr,
div.rendered_html th,
div.rendered_html td {
  text-align: right;
  vertical-align: middle;
  padding: 0.5em 0.5em;
  line-height: normal;
  white-space: normal;
  max-width: none;
  border: none;
}
div.rendered_html th {
  font-weight: bold;
}
div.rendered_html tbody tr:nth-child(odd) {
  background: #f5f5f5;
}
div.rendered_html tbody tr:hover {
  background: rgba(66, 165, 245, 0.2);
}

/* CSS overrides for sphinx_rtd_theme */

/* 24px margin */
.nbinput.nblast.container,
.nboutput.nblast.container {
    margin-bottom: 19px;  /* padding has already 5px */
}

/* ... except between code cells! */
.nblast.container + .nbinput.container {
    margin-top: -19px;
}

.admonition > p:before {
    margin-right: 4px;  /* make room for the exclamation icon */
}

/* Fix math alignment, see https://github.com/rtfd/sphinx_rtd_theme/pull/686 */
.math {
    text-align: unset;
}
</style>
<div class="section" id="Running-a-calibration-with-SHyFT">
<h1>Running a calibration with SHyFT<a class="headerlink" href="#Running-a-calibration-with-SHyFT" title="Permalink to this headline">¶</a></h1>
<div class="section" id="This-notebook-is-guiding-through-the-simulation-process-of-a-catchment.-The-following-steps-are-described:">
<h2>This notebook is guiding through the simulation process of a catchment. The following steps are described:<a class="headerlink" href="#This-notebook-is-guiding-through-the-simulation-process-of-a-catchment.-The-following-steps-are-described:" title="Permalink to this headline">¶</a></h2>
<ol class="arabic simple">
<li><p><strong>Loading required python modules and setting path to SHyFT installation</strong></p></li>
<li><p><strong>Configuration of a SHyFT calibration</strong></p></li>
<li><p><strong>Running a SHyFT calibration</strong></p></li>
<li><p><strong>Inspecting the calibration results</strong></p></li>
</ol>
</div>
<div class="section" id="1.-Loading-required-python-modules-and-setting-path-to-SHyFT-installation">
<h2>1. Loading required python modules and setting path to SHyFT installation<a class="headerlink" href="#1.-Loading-required-python-modules-and-setting-path-to-SHyFT-installation" title="Permalink to this headline">¶</a></h2>
<p>Shyft requires a number of different modules to be loaded as part of the package. Below, we describe the required steps for loading the modules, and note that some steps are only required for the use of the jupyter notebook.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[1]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Pure python modules and jupyter notebook functionality</span>
<span class="c1"># first you should import the third-party python modules which you&#39;ll use later on</span>
<span class="c1"># the first line enables that figures are shown inline, directly in the notebook</span>
<span class="o">%</span><span class="k">pylab</span> inline
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">datetime</span> <span class="k">as</span> <span class="nn">dt</span>
<span class="kn">from</span> <span class="nn">os</span> <span class="kn">import</span> <span class="n">path</span>
<span class="kn">import</span> <span class="nn">sys</span>
<span class="kn">from</span> <span class="nn">matplotlib</span> <span class="kn">import</span> <span class="n">pyplot</span> <span class="k">as</span> <span class="n">plt</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Populating the interactive namespace from numpy and matplotlib
</pre></div></div>
</div>
<div class="section" id="The-Shyft-Environment">
<h3>The Shyft Environment<a class="headerlink" href="#The-Shyft-Environment" title="Permalink to this headline">¶</a></h3>
<p>This next step is highly specific on how and where you have installed Shyft. If you have followed the guidelines at github, and cloned the three shyft repositories: i) shyft, ii) shyft-data, and iii) shyft-doc, then you may need to tell jupyter notebooks where to find shyft. Uncomment the relevant lines below.</p>
<p>If you have a ‘system’ shyft, or used <code class="docutils literal notranslate"><span class="pre">conda</span> <span class="pre">install</span> <span class="pre">-s</span> <span class="pre">sigbjorn</span> <span class="pre">shyft</span></code> to install shyft, then you probably will want to make sure you have set the SHYFT_DATA directory correctly, as otherwise, Shyft will assume the above structure and fail. <strong>This has to be done before ``import shyft``</strong>. In that case, uncomment the relevant lines below.</p>
<p><strong>note</strong>: it is most likely that you’ll need to do one or the other.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[2]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># try to auto-configure the path, -will work in all cases where doc and data</span>
<span class="c1"># are checked out at same level</span>
<span class="n">shyft_data_path</span> <span class="o">=</span> <span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="s2">&quot;../../../shyft-data&quot;</span><span class="p">)</span>
<span class="k">if</span> <span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="n">shyft_data_path</span><span class="p">)</span> <span class="ow">and</span> <span class="s1">&#39;SHYFT_DATA&#39;</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="p">:</span>
    <span class="n">os</span><span class="o">.</span><span class="n">environ</span><span class="p">[</span><span class="s1">&#39;SHYFT_DATA&#39;</span><span class="p">]</span><span class="o">=</span><span class="n">shyft_data_path</span>

<span class="c1"># shyft should be available either by it&#39;s install in python</span>
<span class="c1"># or by PYTHONPATH set by user prior to starting notebook.</span>
<span class="c1"># This is equivalent to the two lines below</span>
<span class="c1">#  shyft_path=path.abspath(&#39;../../../shyft&#39;)</span>
<span class="c1">#  sys.path.insert(0,shyft_path)</span>
</pre></div>
</div>
</div>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[3]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># importing the shyft modules needed for running a calibration</span>
<span class="kn">from</span> <span class="nn">shyft.repository.default_state_repository</span> <span class="kn">import</span> <span class="n">DefaultStateRepository</span>
<span class="kn">from</span> <span class="nn">shyft.orchestration.configuration.yaml_configs</span> <span class="kn">import</span> <span class="n">YAMLCalibConfig</span><span class="p">,</span> <span class="n">YAMLSimConfig</span>
<span class="kn">from</span> <span class="nn">shyft.orchestration.simulators.config_simulator</span> <span class="kn">import</span> <span class="n">ConfigCalibrator</span><span class="p">,</span> <span class="n">ConfigSimulator</span>
</pre></div>
</div>
</div>
</div>
</div>
<div class="section" id="2.-Configuration-of-a-SHyFT-calibration">
<h2>2. Configuration of a SHyFT calibration<a class="headerlink" href="#2.-Configuration-of-a-SHyFT-calibration" title="Permalink to this headline">¶</a></h2>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[4]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># conduct a configured simulation first.</span>
<span class="n">config_file_path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="s2">&quot;../nea-example/nea-config/neanidelva_simulation.yaml&quot;</span><span class="p">)</span>
<span class="n">cfg</span> <span class="o">=</span> <span class="n">YAMLSimConfig</span><span class="p">(</span><span class="n">config_file_path</span><span class="p">,</span> <span class="s2">&quot;neanidelva&quot;</span><span class="p">)</span>
<span class="n">simulator</span> <span class="o">=</span> <span class="n">ConfigSimulator</span><span class="p">(</span><span class="n">cfg</span><span class="p">)</span>
<span class="c1"># run the model, and we&#39;ll just pull the `api.model` from the `simulator`</span>
<span class="n">simulator</span><span class="o">.</span><span class="n">run</span><span class="p">()</span>
<span class="n">state</span> <span class="o">=</span> <span class="n">simulator</span><span class="o">.</span><span class="n">region_model</span><span class="o">.</span><span class="n">state</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area stderr docutils container">
<div class="highlight"><pre>
/home/sih/projects/shyft/shyft/repository/netcdf/utils.py:351: RuntimeWarning: invalid value encountered in greater
  pure_arr = nc_var[data_slice][tuple(xy_slice_mask)]
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Running simulation...
</pre></div></div>
</div>
<p>Now that we have the initial state, we’ll run the calibration (this is not a strictly required step, but we use it later)</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[5]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># set up configuration using *.yaml configuration files</span>
<span class="n">config_file_path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="s2">&quot;./nea-config/neanidelva_calibration.yaml&quot;</span><span class="p">)</span> <span class="c1"># here is the *.yaml file</span>
<span class="n">cfg</span> <span class="o">=</span> <span class="n">YAMLCalibConfig</span><span class="p">(</span><span class="n">config_file_path</span><span class="p">,</span> <span class="s2">&quot;neanidelva&quot;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[6]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># initialize an instance of the orchestration&#39;s ConfigCalcalibrator class, which has all the functionality needed</span>
<span class="c1"># to run a calibration using the above initiated configuration</span>
<span class="n">calib</span> <span class="o">=</span> <span class="n">ConfigCalibrator</span><span class="p">(</span><span class="n">cfg</span><span class="p">)</span>
<span class="n">n_cells</span> <span class="o">=</span> <span class="n">calib</span><span class="o">.</span><span class="n">region_model</span><span class="o">.</span><span class="n">size</span><span class="p">()</span>
<span class="n">state_repos</span> <span class="o">=</span> <span class="n">DefaultStateRepository</span><span class="p">(</span><span class="n">calib</span><span class="o">.</span><span class="n">region_model</span><span class="p">)</span>  <span class="c1"># Notice that this repository needs the real model</span>
<span class="c1">#                                                           so that it&#39;s able to generate a precise</span>
<span class="c1">#                                                           default state-with-id vector for this</span>
<span class="c1">#                                                           specific model</span>

</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Creating TargetSpecificationVector...
</pre></div></div>
</div>
</div>
<div class="section" id="3.-Running-a-SHyFT-calibration">
<h2>3. Running a SHyFT calibration<a class="headerlink" href="#3.-Running-a-SHyFT-calibration" title="Permalink to this headline">¶</a></h2>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[7]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># once the calibrator is set up, all you need to do is running the calibration...</span>
<span class="c1"># the calibrated parameters are stored in a model.yaml.</span>
<span class="n">results</span> <span class="o">=</span> <span class="n">calib</span><span class="o">.</span><span class="n">calibrate</span><span class="p">(</span><span class="n">cfg</span><span class="o">.</span><span class="n">sim_config</span><span class="o">.</span><span class="n">time_axis</span><span class="p">,</span> <span class="n">state_repos</span><span class="o">.</span><span class="n">get_state</span><span class="p">(</span><span class="mi">0</span><span class="p">)</span><span class="o">.</span><span class="n">state_vector</span><span class="p">,</span>
                          <span class="n">cfg</span><span class="o">.</span><span class="n">optimization_method</span><span class="p">[</span><span class="s1">&#39;name&#39;</span><span class="p">],</span>
                          <span class="n">cfg</span><span class="o">.</span><span class="n">optimization_method</span><span class="p">[</span><span class="s1">&#39;params&#39;</span><span class="p">])</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Calibrating...
Storing calibrated params in: /home/sih/projects/shyft-doc/notebooks/nea-example/nea-config/calibrated_model.yaml
</pre></div></div>
</div>
</div>
<div class="section" id="4.-Inspecting-the-calibration-results">
<h2>4. Inspecting the calibration results<a class="headerlink" href="#4.-Inspecting-the-calibration-results" title="Permalink to this headline">¶</a></h2>
<p>First the Nash-Suttcliffe-efficiency of the calibrated simulation is computed to see the quality of the calibration. Then the calibrated model parameters are accessed and printed out.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[8]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Get NSE of calibrated run:</span>
<span class="n">result_params</span> <span class="o">=</span> <span class="p">[]</span>
<span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">results</span><span class="o">.</span><span class="n">size</span><span class="p">()):</span>
    <span class="n">result_params</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">results</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">i</span><span class="p">))</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Final NSE =&quot;</span><span class="p">,</span> <span class="mi">1</span><span class="o">-</span><span class="n">calib</span><span class="o">.</span><span class="n">optimizer</span><span class="o">.</span><span class="n">calculate_goal_function</span><span class="p">(</span><span class="n">result_params</span><span class="p">))</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Final NSE = 0.8613306341465994
</pre></div></div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[9]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># Check out the calibrated parameters.</span>

<span class="n">diff</span> <span class="o">=</span> <span class="mf">1.0E-3</span>
<span class="nb">print</span><span class="p">(</span><span class="s2">&quot;</span><span class="si">{0:30s}</span><span class="s2"> </span><span class="si">{1:10s}</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="s2">&quot;PARAM-NAME&quot;</span><span class="p">,</span> <span class="s2">&quot;CALIB-VALUE&quot;</span><span class="p">))</span>

<span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="n">results</span><span class="o">.</span><span class="n">size</span><span class="p">()):</span>
    <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;</span><span class="si">{0:30s}</span><span class="s2"> </span><span class="si">{1:10f}</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">results</span><span class="o">.</span><span class="n">get_name</span><span class="p">(</span><span class="n">i</span><span class="p">),</span> <span class="n">results</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">i</span><span class="p">)))</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
PARAM-NAME                     CALIB-VALUE
kirchner.c1                     -3.597688
kirchner.c2                      0.144172
kirchner.c3                     -0.149944
ae.ae_scale_factor               1.500000
gs.tx                           -1.025714
gs.wind_scale                    2.092050
gs.max_water                     0.100000
gs.wind_const                    1.000000
gs.fast_albedo_decay_rate        5.000870
gs.slow_albedo_decay_rate       30.225223
gs.surface_magnitude            30.000000
gs.max_albedo                    0.900000
gs.min_albedo                    0.600000
gs.snowfall_reset_depth          5.000000
gs.snow_cv                       0.400000
gs.glacier_albedo                0.400000
p_corr.scale_factor              1.000000
gs.snow_cv_forest_factor         0.000000
gs.snow_cv_altitude_factor       0.000000
pt.albedo                        0.200000
pt.alpha                         1.260000
gs.initial_bare_ground_fraction   0.040000
gs.winter_end_day_of_year      100.000000
gs.calculate_iso_pot_energy      0.000000
gm.dtf                           6.000000
routing.velocity                 0.000000
routing.alpha                    0.900000
routing.beta                     3.000000
gs.n_winter_days               221.000000
gm.direct_response               0.474810
msp.reservoir_direct_response_fraction   1.000000
</pre></div></div>
</div>
<div class="section" id="Plotting-simulated-and-observed-discharge">
<h3>Plotting simulated and observed discharge<a class="headerlink" href="#Plotting-simulated-and-observed-discharge" title="Permalink to this headline">¶</a></h3>
<p>We are now plotting the simulated and observed discharge timeseries over the course of the melt period.</p>
<div class="nbinput nblast docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[10]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># get the target vector and discharge statistics from the configured calibrator</span>
<span class="n">target_obs</span> <span class="o">=</span> <span class="n">calib</span><span class="o">.</span><span class="n">tv</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
<span class="n">disch_sim</span> <span class="o">=</span> <span class="n">calib</span><span class="o">.</span><span class="n">region_model</span><span class="o">.</span><span class="n">statistics</span><span class="o">.</span><span class="n">discharge</span><span class="p">(</span><span class="n">target_obs</span><span class="o">.</span><span class="n">catchment_indexes</span><span class="p">)</span>
<span class="n">disch_obs</span> <span class="o">=</span> <span class="n">target_obs</span><span class="o">.</span><span class="n">ts</span><span class="o">.</span><span class="n">values</span>

<span class="n">ts_timestamps</span> <span class="o">=</span> <span class="p">[</span><span class="n">dt</span><span class="o">.</span><span class="n">datetime</span><span class="o">.</span><span class="n">utcfromtimestamp</span><span class="p">(</span><span class="n">p</span><span class="o">.</span><span class="n">start</span><span class="p">)</span> <span class="k">for</span> <span class="n">p</span> <span class="ow">in</span> <span class="n">target_obs</span><span class="o">.</span><span class="n">ts</span><span class="o">.</span><span class="n">time_axis</span><span class="p">]</span>

</pre></div>
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[11]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="c1"># plot up the results</span>
<span class="n">fig</span><span class="p">,</span> <span class="n">ax</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplots</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">15</span><span class="p">,</span><span class="mi">10</span><span class="p">))</span>
<span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">ts_timestamps</span><span class="p">,</span> <span class="n">disch_sim</span><span class="o">.</span><span class="n">values</span><span class="p">,</span> <span class="n">lw</span><span class="o">=</span><span class="mi">2</span><span class="p">,</span> <span class="n">label</span> <span class="o">=</span> <span class="s2">&quot;sim&quot;</span><span class="p">)</span>
<span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">ts_timestamps</span><span class="p">,</span> <span class="n">disch_obs</span><span class="p">,</span> <span class="n">lw</span><span class="o">=</span><span class="mi">2</span><span class="p">,</span> <span class="n">ls</span><span class="o">=</span><span class="s1">&#39;--&#39;</span><span class="p">,</span> <span class="n">label</span> <span class="o">=</span> <span class="s2">&quot;obs&quot;</span><span class="p">)</span>
<span class="n">ax</span><span class="o">.</span><span class="n">set_title</span><span class="p">(</span><span class="s2">&quot;observed and simulated discharge&quot;</span><span class="p">)</span>
<span class="n">ax</span><span class="o">.</span><span class="n">legend</span><span class="p">()</span>
<span class="n">ax</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="s2">&quot;discharge [m3 s-1]&quot;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[11]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Text(0, 0.5, &#39;discharge [m3 s-1]&#39;)
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/notebooks_nea-example_calibration-configured_18_1.png" src="../../_images/notebooks_nea-example_calibration-configured_18_1.png" />
</div>
</div>
</div>
</div>
<div class="section" id="5.-Changing-parameters-on-the-fly">
<h2>5. Changing parameters on-the-fly<a class="headerlink" href="#5.-Changing-parameters-on-the-fly" title="Permalink to this headline">¶</a></h2>
<p>Instead of changing model parameters in the yaml-configs, reload the configuration and re-run the model, we can also just change the parameters “on-the-fly”, and rerun the model. This makes it easy to investigate the influence of certain model parameters on the simulation results.</p>
<div class="section" id="5a.-Snow-or-rain?-The-parameter-gs.tx-sets-the-threshold-temperature-at-which-precipitation-is-treated-as-snow-fall.">
<h3>5a. Snow or rain? The parameter gs.tx sets the threshold temperature at which precipitation is treated as snow fall.<a class="headerlink" href="#5a.-Snow-or-rain?-The-parameter-gs.tx-sets-the-threshold-temperature-at-which-precipitation-is-treated-as-snow-fall." title="Permalink to this headline">¶</a></h3>
<p>In the following we’ll investigate the impact of manually manipulating this parameter.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[12]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">parameters</span> <span class="o">=</span> <span class="n">calib</span><span class="o">.</span><span class="n">region_model</span><span class="o">.</span><span class="n">get_region_parameter</span><span class="p">()</span> <span class="c1"># fetching parameters from the simulator object</span>
<span class="nb">print</span><span class="p">(</span><span class="sa">u</span><span class="s2">&quot;Calibrated rain/snow threshold temp: </span><span class="si">{}</span><span class="s2"> C&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">parameters</span><span class="o">.</span><span class="n">gs</span><span class="o">.</span><span class="n">tx</span><span class="p">))</span> <span class="c1"># print current value of hs.tx</span>
</pre></div>
</div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Calibrated rain/snow threshold temp: -1.025713820537678 C
</pre></div></div>
</div>
<p>In the following, we first set the hs.tx parameter to a higher, and then to a lower value compared to the value the calibration results suggest. We re-run the simulation, respicetively, and plot the results.</p>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[13]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">calib</span><span class="o">.</span><span class="n">optimizer</span><span class="o">.</span><span class="n">calculate_goal_function</span><span class="p">(</span><span class="n">result_params</span><span class="p">)</span> <span class="c1"># reset the parameters to the values of the calibration</span>
<span class="n">parameters</span><span class="o">.</span><span class="n">gs</span><span class="o">.</span><span class="n">tx</span> <span class="o">=</span> <span class="mf">4.0</span> <span class="c1"># setting a higher value for tx</span>
<span class="n">s_init</span> <span class="o">=</span> <span class="n">state</span><span class="o">.</span><span class="n">extract_state</span><span class="p">([])</span>
<span class="c1"># type(state)</span>
<span class="c1"># s0=state_repos.get_state(0)</span>
<span class="c1"># s0.state_vector</span>
<span class="c1"># state.apply_state(s0, [])</span>
<span class="n">calib</span><span class="o">.</span><span class="n">run</span><span class="p">(</span><span class="n">state</span><span class="o">=</span><span class="n">s_init</span><span class="p">)</span> <span class="c1"># rerun the model, with new parameter</span>
<span class="n">disch_sim_p_high</span> <span class="o">=</span> <span class="n">calib</span><span class="o">.</span><span class="n">region_model</span><span class="o">.</span><span class="n">statistics</span><span class="o">.</span><span class="n">discharge</span><span class="p">(</span><span class="n">target_obs</span><span class="o">.</span><span class="n">catchment_indexes</span><span class="p">)</span> <span class="c1"># fetch discharge ts</span>
<span class="n">parameters</span><span class="o">.</span><span class="n">gs</span><span class="o">.</span><span class="n">tx</span> <span class="o">=</span> <span class="o">-</span><span class="mf">4.0</span> <span class="c1"># setting a higher value for tx</span>

<span class="n">calib</span><span class="o">.</span><span class="n">run</span><span class="p">(</span><span class="n">state</span><span class="o">=</span><span class="n">s_init</span><span class="p">)</span> <span class="c1"># rerun the model, with new parameter</span>

<span class="n">disch_sim_p_low</span> <span class="o">=</span> <span class="n">calib</span><span class="o">.</span><span class="n">region_model</span><span class="o">.</span><span class="n">statistics</span><span class="o">.</span><span class="n">discharge</span><span class="p">(</span><span class="n">target_obs</span><span class="o">.</span><span class="n">catchment_indexes</span><span class="p">)</span> <span class="c1"># fetch discharge ts</span>
<span class="n">fig</span><span class="p">,</span> <span class="n">ax</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplots</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">15</span><span class="p">,</span><span class="mi">10</span><span class="p">))</span>
<span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">ts_timestamps</span><span class="p">,</span> <span class="n">disch_sim</span><span class="o">.</span><span class="n">values</span><span class="p">,</span> <span class="n">lw</span><span class="o">=</span><span class="mi">2</span><span class="p">,</span> <span class="n">label</span> <span class="o">=</span> <span class="s2">&quot;calib&quot;</span><span class="p">)</span>
<span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">ts_timestamps</span><span class="p">,</span> <span class="n">disch_sim_p_high</span><span class="o">.</span><span class="n">values</span><span class="p">,</span> <span class="n">lw</span><span class="o">=</span><span class="mi">2</span><span class="p">,</span> <span class="n">label</span> <span class="o">=</span> <span class="s2">&quot;high&quot;</span><span class="p">)</span>
<span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">ts_timestamps</span><span class="p">,</span> <span class="n">disch_sim_p_low</span><span class="o">.</span><span class="n">values</span><span class="p">,</span> <span class="n">lw</span><span class="o">=</span><span class="mi">2</span><span class="p">,</span> <span class="n">label</span> <span class="o">=</span> <span class="s2">&quot;low&quot;</span><span class="p">)</span>
<span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">ts_timestamps</span><span class="p">,</span> <span class="n">disch_obs</span><span class="p">,</span> <span class="n">lw</span><span class="o">=</span><span class="mi">2</span><span class="p">,</span> <span class="n">ls</span><span class="o">=</span><span class="s1">&#39;--&#39;</span><span class="p">,</span> <span class="n">label</span> <span class="o">=</span> <span class="s2">&quot;obs&quot;</span><span class="p">)</span>
<span class="n">ax</span><span class="o">.</span><span class="n">set_title</span><span class="p">(</span><span class="s2">&quot;investigating parameter gs.tx&quot;</span><span class="p">)</span>
<span class="n">ax</span><span class="o">.</span><span class="n">legend</span><span class="p">()</span>
<span class="n">ax</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="s2">&quot;discharge [m3 s-1]&quot;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Running simulation...
Running simulation...
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[13]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Text(0, 0.5, &#39;discharge [m3 s-1]&#39;)
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/notebooks_nea-example_calibration-configured_22_2.png" src="../../_images/notebooks_nea-example_calibration-configured_22_2.png" />
</div>
</div>
<div class="nbinput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[14]:
</pre></div>
</div>
<div class="input_area highlight-ipython3 notranslate"><div class="highlight"><pre>
<span></span><span class="n">s_init</span> <span class="o">=</span> <span class="n">state</span><span class="o">.</span><span class="n">extract_state</span><span class="p">([])</span>

<span class="c1"># reset the max water parameter</span>
<span class="n">parameters</span><span class="o">.</span><span class="n">gs</span><span class="o">.</span><span class="n">max_water</span> <span class="o">=</span> <span class="mf">1.0</span> <span class="c1"># setting a higher value for tx</span>
<span class="n">calib</span><span class="o">.</span><span class="n">run</span><span class="p">(</span><span class="n">state</span><span class="o">=</span><span class="n">s_init</span><span class="p">)</span> <span class="c1"># rerun the model, with new parameter</span>
<span class="n">disch_sim_p_high</span> <span class="o">=</span> <span class="n">calib</span><span class="o">.</span><span class="n">region_model</span><span class="o">.</span><span class="n">statistics</span><span class="o">.</span><span class="n">discharge</span><span class="p">(</span><span class="n">target_obs</span><span class="o">.</span><span class="n">catchment_indexes</span><span class="p">)</span> <span class="c1"># fetch discharge ts</span>

<span class="n">parameters</span><span class="o">.</span><span class="n">gs</span><span class="o">.</span><span class="n">max_water</span> <span class="o">=</span> <span class="o">.</span><span class="mi">001</span> <span class="c1"># setting a higher value for tx</span>
<span class="n">calib</span><span class="o">.</span><span class="n">run</span><span class="p">(</span><span class="n">state</span><span class="o">=</span><span class="n">s_init</span><span class="p">)</span> <span class="c1"># rerun the model, with new parameter</span>
<span class="n">disch_sim_p_low</span> <span class="o">=</span> <span class="n">calib</span><span class="o">.</span><span class="n">region_model</span><span class="o">.</span><span class="n">statistics</span><span class="o">.</span><span class="n">discharge</span><span class="p">(</span><span class="n">target_obs</span><span class="o">.</span><span class="n">catchment_indexes</span><span class="p">)</span> <span class="c1"># fetch discharge ts</span>

<span class="c1"># plot the results</span>
<span class="n">fig</span><span class="p">,</span> <span class="n">ax</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">subplots</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">15</span><span class="p">,</span><span class="mi">10</span><span class="p">))</span>
<span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">ts_timestamps</span><span class="p">,</span> <span class="n">disch_sim</span><span class="o">.</span><span class="n">values</span><span class="p">,</span> <span class="n">lw</span><span class="o">=</span><span class="mi">2</span><span class="p">,</span> <span class="n">label</span> <span class="o">=</span> <span class="s2">&quot;calib&quot;</span><span class="p">)</span>
<span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">ts_timestamps</span><span class="p">,</span> <span class="n">disch_sim_p_high</span><span class="o">.</span><span class="n">values</span><span class="p">,</span> <span class="n">lw</span><span class="o">=</span><span class="mi">2</span><span class="p">,</span> <span class="n">label</span> <span class="o">=</span> <span class="s2">&quot;high&quot;</span><span class="p">)</span>
<span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">ts_timestamps</span><span class="p">,</span> <span class="n">disch_sim_p_low</span><span class="o">.</span><span class="n">values</span><span class="p">,</span> <span class="n">lw</span><span class="o">=</span><span class="mi">2</span><span class="p">,</span> <span class="n">label</span> <span class="o">=</span> <span class="s2">&quot;low&quot;</span><span class="p">)</span>
<span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">ts_timestamps</span><span class="p">,</span> <span class="n">disch_obs</span><span class="p">,</span> <span class="n">lw</span><span class="o">=</span><span class="mi">2</span><span class="p">,</span> <span class="n">ls</span><span class="o">=</span><span class="s1">&#39;--&#39;</span><span class="p">,</span> <span class="n">label</span> <span class="o">=</span> <span class="s2">&quot;obs&quot;</span><span class="p">)</span>
<span class="n">ax</span><span class="o">.</span><span class="n">set_title</span><span class="p">(</span><span class="s2">&quot;investigating parameter gs.max_water&quot;</span><span class="p">)</span>
<span class="n">ax</span><span class="o">.</span><span class="n">legend</span><span class="p">()</span>
<span class="n">ax</span><span class="o">.</span><span class="n">set_ylabel</span><span class="p">(</span><span class="s2">&quot;discharge [m3 s-1]&quot;</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="nboutput docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Running simulation...
Running simulation...
</pre></div></div>
</div>
<div class="nboutput docutils container">
<div class="prompt highlight-none notranslate"><div class="highlight"><pre><span></span>[14]:
</pre></div>
</div>
<div class="output_area docutils container">
<div class="highlight"><pre>
Text(0, 0.5, &#39;discharge [m3 s-1]&#39;)
</pre></div></div>
</div>
<div class="nboutput nblast docutils container">
<div class="prompt empty docutils container">
</div>
<div class="output_area docutils container">
<img alt="../../_images/notebooks_nea-example_calibration-configured_23_2.png" src="../../_images/notebooks_nea-example_calibration-configured_23_2.png" />
</div>
</div>
</div>
</div>
</div>


           </div>
           
          </div>
          <footer>
  
    <div class="rst-footer-buttons" role="navigation" aria-label="footer navigation">
      
        <a href="simulation-configured.html" class="btn btn-neutral float-right" title="Configured Shyft simulations" accesskey="n" rel="next">Next <span class="fa fa-arrow-circle-right"></span></a>
      
      
        <a href="../shyft-intro-course-master/run_api_model.html" class="btn btn-neutral float-left" title="Constructing a model using the Shyft API" accesskey="p" rel="prev"><span class="fa fa-arrow-circle-left"></span> Previous</a>
      
    </div>
  

  <hr/>

  <div role="contentinfo">
    <p>
        &copy; Copyright 2021, The Shyft project

    </p>
  </div>
  Built with <a href="http://sphinx-doc.org/">Sphinx</a> using a <a href="https://github.com/rtfd/sphinx_rtd_theme">theme</a> provided by <a href="https://readthedocs.org">Read the Docs</a>. 

</footer>

        </div>
      </div>

    </section>

  </div>
  


  <script type="text/javascript">
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script>

  
  
    
   

</body>
</html>